## metabat 2.15

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.5.1)
project (MetaBAT)

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release)
endif()

message("Installing ${CMAKE_BUILD_TYPE} MetaBAT into ${CMAKE_INSTALL_PREFIX}")

include(${CMAKE_ROOT}/Modules/ExternalProject.cmake)
include(cmake/zlib.cmake)
include(cmake/htslib.cmake)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

set(CMAKE_C_STANDARD 99)
set(CMAKE_C_STANDARD_REQUIRED ON)
set(CMAKE_C_EXTENSIONS OFF)

add_definitions(-D_XOPEN_SOURCE=700)

set(PRE_CONFIGURE_FILE "metabat_version.h.in")
set(POST_CONFIGURE_FILE "metabat_version.h")
include(cmake/git-watcher.cmake)

if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
  # using Clang
elseif ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "AppleClang")
  # using AppleClang
elseif ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
  # using GCC
  if ("${CMAKE_BUILD_TYPE}" STREQUAL "Release")
      set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} -mtune=native")
      set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -mtune=native")
  endif()
elseif ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Intel")
  # using Intel C++
endif()

include_directories(${CMAKE_SOURCE_DIR})

add_subdirectory(src)

if (NOT NO_TESTING)
    enable_testing()
    add_subdirectory(test)
endif()

install(PROGRAMS runMetaBat.sh merge_depths.pl aggregateBinDepths.pl aggregateContigOverlapsByBin.pl
        DESTINATION bin/
       )
INSTALL(CODE "execute_process( \
    COMMAND ${CMAKE_COMMAND} -E create_symlink \
    metabat2 \
    ${CMAKE_INSTALL_PREFIX}/bin/metabat   \
    )"
)

=== src/CMakeLists.txt ===
# find and use Boost
set(Boost_NO_BOOST_CMAKE ON) # for backwards comptibility of cmake and boost >= 1.70
set(Boost_USE_STATIC_LIBS   ON)
find_package(Boost 1.55.0 COMPONENTS program_options filesystem system graph serialization iostreams REQUIRED)
include_directories( ${Boost_INCLUDE_DIRS} )

# find and use OpenMP
find_package(OpenMP)

if (OPENMP_FOUND)
    set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
    set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${OpenMP_EXE_LINKER_FLAGS}")
    message("Using OpenMP")
else()
    message(WARNING "OpenMP must be available to your compiler or it will be REALLLLLLLLLLY slow: ${CMAKE_C_COMPILER} ${CMAKE_CXX_COMPILER}")
endif()

if(APPLE)
	#full Single Unix Standard v3 (SUSv3) conformance (the Unix API)
	add_definitions(-D_DARWIN_C_SOURCE)
endif()

if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "XL")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -qreport -qhot -qmaxmem=819200 -qoffload -qtgtarch=sm_70 -g")
set(EXTRALIBS ${EXTRALIBS} )
endif()

message("Boost cmake dir: ${Boost_DIR}")
message("Boost include: ${Boost_INCLUDE_DIRS}")
message("Boost libraries:" ${Boost_LIBRARIES})
message("Boost lib ver:" ${Boost_LIB_VERSION})
message("Boost lib dir:" ${Boost_LIBRARY_DIRS})

set(targets metabat1 metabat2)
foreach(target ${targets})

   add_executable(${target} ${target}.cpp)
   add_dependencies(${target} htslib zlib check_git_repository)
   target_link_libraries(${target} ${zlib_LIB} ${Boost_LIBRARIES} ${EXTRALIBS} ) 

endforeach()

install(TARGETS ${targets}
        DESTINATION bin/
       )

set(targets jgi_summarize_bam_contig_depths contigOverlaps)
foreach(target ${targets})
   add_executable(${target} ${target}.cpp)
   add_dependencies(${target} htslib zlib check_git_repository)
   target_link_libraries(${target} ${htslib_LIB} ${zlib_LIB} ${Boost_LIBRARIES} ) 
endforeach()


install(TARGETS ${targets}
        DESTINATION bin/
       )

=== test/CMakeLists.txt ===

set(CTEST_OUTPUT_ON_FAILURE 1)

add_test(NAME test_depths
         COMMAND ${CMAKE_BINARY_DIR}/src/jgi_summarize_bam_contig_depths --referenceFasta ${CMAKE_CURRENT_SOURCE_DIR}/contigs.fa --outputDepth ${CMAKE_BINARY_DIR}/contigs_depth.txt ${CMAKE_CURRENT_SOURCE_DIR}/contigs-1000.fastq.bam
        )

add_test(NAME test_metabat1
         COMMAND ${CMAKE_BINARY_DIR}/src/metabat1 --inFile ${CMAKE_CURRENT_SOURCE_DIR}/contigs.fa --abdFile ${CMAKE_BINARY_DIR}/contigs_depth.txt --outFile ${CMAKE_BINARY_DIR}/contigs_bins -v
        )

add_test(NAME test_metabat2
         COMMAND ${CMAKE_BINARY_DIR}/src/metabat2 --inFile ${CMAKE_CURRENT_SOURCE_DIR}/contigs.fa --abdFile ${CMAKE_BINARY_DIR}/contigs_depth.txt --outFile ${CMAKE_BINARY_DIR}/contigs_bins -v
        )

=== debian/changelog ===
metabat (2.15-4) unstable; urgency=medium

  * Fix watch file
  * Standards-Version: 4.6.1 (routine-update)

 -- Andreas Tille <tille@debian.org>  Thu, 29 Sep 2022 18:15:48 +0200

metabat (2.15-3) unstable; urgency=medium

  * Restrict Architecture: any-amd64 any-i386 x32
    Closes: #976528
  * Standards-Version: 4.5.1 (routine-update)

 -- Andreas Tille <tille@debian.org>  Sat, 05 Dec 2020 21:40:34 +0100

metabat (2.15-2) unstable; urgency=medium

  * Remove trailing whitespace in debian/copyright (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Set upstream metadata fields: Repository.

 -- Andreas Tille <tille@debian.org>  Wed, 15 Jul 2020 10:35:24 +0200

metabat (2.15-1) unstable; urgency=medium

  * Initial release (Closes: #961946)

 -- Andreas Tille <tille@debian.org>  Sun, 31 May 2020 23:08:58 +0200

=== debian/control ===
Source: metabat
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake,
               libboost-graph-dev,
               libboost-system-dev,
               libboost-filesystem-dev,
               libboost-serialization-dev,
               libboost-program-options-dev,
               libboost-iostreams-dev,
               zlib1g-dev,
               libhts-dev,
               pkg-config,
               python3
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/med-team/metabat
Vcs-Git: https://salsa.debian.org/med-team/metabat.git
Homepage: https://bitbucket.org/berkeleylab/metabat/wiki/Home
Rules-Requires-Root: no

Package: metabat
Architecture: any-amd64 any-i386 x32
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: robust statistical framework for reconstructing genomes from metagenomic data
 MetaBAT integrates empirical probabilistic distances of genome abundance
 and tetranucleotide frequency for accurate metagenome binning. MetaBAT
 outperforms alternative methods in accuracy and computational efficiency
 on both synthetic and real metagenome datasets. It automatically forms
 hundreds of high quality genome bins on a very large assembly consisting
 millions of contigs in a matter of hours on a single node.

=== debian/watch ===
version=4

opts="mode=git,gitmode=full,dversionmangle=auto" \
  https://bitbucket.org/berkeleylab/metabat.git refs/tags/v([\d\.\d]+)

# https://bitbucket.org/berkeleylab/metabat/downloads/?tab=tags .*/@PACKAGE@/get/v@ANY_VERSION@\.tar\.gz

## metabat 2.18

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,17 +5,53 @@
   set(CMAKE_BUILD_TYPE Release)
 endif()
 
-message("Installing ${CMAKE_BUILD_TYPE} MetaBAT into ${CMAKE_INSTALL_PREFIX}")
+message(STATUS "Installing ${CMAKE_BUILD_TYPE} MetaBAT into ${CMAKE_INSTALL_PREFIX}")
 
-include(${CMAKE_ROOT}/Modules/ExternalProject.cmake)
-include(cmake/zlib.cmake)
-include(cmake/htslib.cmake)
+set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/cmake/Modules )
+include(GetGitVersion)
 
-set(CMAKE_CXX_STANDARD 11)
+set(EXTRA_DEPENDENCIES "")
+
+option(METABAT_USE_SYSTEM_ZLIB "Try to find and use system ZLIB" ON)
+if(METABAT_USE_SYSTEM_ZLIB)
+  find_package(ZLIB 1.2.11)
+  if(NOT ZLIB_FOUND)
+    message(STATUS "Could not find a system version of zlib")
+  endif()
+else()
+  message(STATUS "Skipping system detection of system install of zlib")
+endif()
+if (NOT ZLIB_FOUND)
+  message(STATUS "Including zlib via add_external_project")
+  include(${PROJECT_SOURCE_DIR}/cmake/zlib.cmake)
+  set(EXTRA_DEPENDENCIES ${EXTRA_DEPENDENCIES} zlib)
+else()
+  message(STATUS "Using system zlib")
+endif()
+
+option(METABAT_USE_SYSTEM_HTSLIB "Try to find and use system HTSLIB" ON)
+if(METABAT_USE_SYSTEM_HTSLIB)
+  #include(FindHTSlib)
+  find_package(HTSlib 1.13)
+  if (NOT HTSlib_FOUND)
+    message(STATUS "Could not find a system installation of htslib")
+  endif()
+else()
+  message(STATUS "Skipping detection of system install of htslib")
+endif()
+if (NOT HTSlib_FOUND)
+  message(STATUS "Including htslib via add_external_project")
+  include(${PROJECT_SOURCE_DIR}/cmake/htslib.cmake)
+  set(EXTRA_DEPENDENCIES ${EXTRA_DEPENDENCIES} htslib)
+else()
+  message(STATUS "using system htslib")
+endif()
+
+set(CMAKE_CXX_STANDARD 17)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 set(CMAKE_CXX_EXTENSIONS OFF)
 
-set(CMAKE_C_STANDARD 99)
+set(CMAKE_C_STANDARD 17)
 set(CMAKE_C_STANDARD_REQUIRED ON)
 set(CMAKE_C_EXTENSIONS OFF)
 
@@ -23,7 +59,6 @@
 
 set(PRE_CONFIGURE_FILE "metabat_version.h.in")
 set(POST_CONFIGURE_FILE "metabat_version.h")
-include(cmake/git-watcher.cmake)
 
 if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
   # using Clang
@@ -41,6 +76,8 @@
 
 include_directories(${CMAKE_SOURCE_DIR})
 
+get_git_version(MetaBAT)
+
 add_subdirectory(src)
 
 if (NOT NO_TESTING)
@@ -48,7 +85,8 @@
     add_subdirectory(test)
 endif()
 
-install(PROGRAMS runMetaBat.sh merge_depths.pl aggregateBinDepths.pl aggregateContigOverlapsByBin.pl
+install(PROGRAMS runMetaBat.sh filter_sam_by_min_len.py aggregateBinDepths.pl aggregateContigOverlapsByBin.pl
+                 merge_abundances.py merge_depths-DEPRECATED.pl
         DESTINATION bin/
        )
 INSTALL(CODE "execute_process( \

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -36,8 +36,10 @@
 foreach(target ${targets})
 
    add_executable(${target} ${target}.cpp)
-   add_dependencies(${target} htslib zlib check_git_repository)
-   target_link_libraries(${target} ${zlib_LIB} ${Boost_LIBRARIES} ${EXTRALIBS} ) 
+   if(NOT "${EXTRA_DEPENDENCIES}" STREQUAL "")
+     add_dependencies(${target} ${EXTRA_DEPENDENCIES})
+   endif()
+   target_link_libraries(${target} ${ZLIB_LIBRARIES} ${Boost_LIBRARIES} ${EXTRALIBS} MetaBAT_VERSION_LIB) 
 
 endforeach()
 
@@ -48,8 +50,10 @@
 set(targets jgi_summarize_bam_contig_depths contigOverlaps)
 foreach(target ${targets})
    add_executable(${target} ${target}.cpp)
-   add_dependencies(${target} htslib zlib check_git_repository)
-   target_link_libraries(${target} ${htslib_LIB} ${zlib_LIB} ${Boost_LIBRARIES} ) 
+   if (NOT "${EXTRA_DEPENDENCIES}" STREQUAL "")
+     add_dependencies(${target} ${EXTRA_DEPENDENCIES})
+   endif()
+   target_link_libraries(${target} ${HTSlib_LIBRARIES} ${ZLIB_LIBRARIES} ${Boost_LIBRARIES} MetaBAT_VERSION_LIB) 
 endforeach()

=== test/CMakeLists.txt ===

set(CTEST_OUTPUT_ON_FAILURE 1)

file(MAKE_DIRECTORY  ${CMAKE_BINARY_DIR}/test-each)
add_test(NAME test_depths
         COMMAND ${CMAKE_BINARY_DIR}/src/jgi_summarize_bam_contig_depths --referenceFasta ${CMAKE_CURRENT_SOURCE_DIR}/contigs.fa --outputDepth contigs_depth.txt ${CMAKE_CURRENT_SOURCE_DIR}/contigs-1000.fastq.bam
         WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/test-each
        )

file(MAKE_DIRECTORY  ${CMAKE_BINARY_DIR}/test-each)
add_test(NAME test_metabat1
         COMMAND ${CMAKE_BINARY_DIR}/src/metabat1 --inFile ${CMAKE_CURRENT_SOURCE_DIR}/contigs.fa --abdFile contigs_depth.txt --outFile metabat1/contigs_bins -v
         WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/test-each
        )

file(MAKE_DIRECTORY  ${CMAKE_BINARY_DIR}/test-each)
add_test(NAME test_metabat2
         COMMAND ${CMAKE_BINARY_DIR}/src/metabat2 --minClsSize 0 --inFile ${CMAKE_CURRENT_SOURCE_DIR}/contigs.fa --abdFile contigs_depth.txt --outFile metabat2/contigs_bins -v
         WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/test-each
        )

file(COPY ${CMAKE_SOURCE_DIR}/runMetaBat.sh DESTINATION ${CMAKE_BINARY_DIR}/src)
file(MAKE_DIRECTORY  ${CMAKE_BINARY_DIR}/test-runMetaBat)
add_test(NAME runMetaBat.sh
         COMMAND  ${CMAKE_BINARY_DIR}/src/runMetaBat.sh --minClsSize 0 ${CMAKE_CURRENT_SOURCE_DIR}/contigs.fa ${CMAKE_CURRENT_SOURCE_DIR}/contigs-1000.fastq.bam
         WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/test-runMetaBat
        )

=== debian/changelog ===
metabat (2.18-1) unstable; urgency=medium

  [ Andreas Tille ]
  * New upstream version
  * Standards-Version: 4.7.2 (routine-update)
  * Add python3 explicitly to Depends
  * Fix build with CMake 4
    Closes: #1113279
  * d/watch: version=5
  * Replace transitional package pkg-config by pkgconf in Build-Depends
    (routine-update)
  * No need to patch CMakeLists.txt any more which since configuration
    by variables enables using local libs
  * d/copyright: review

  [ Étienne Mollier ]
  * d/rules: do not parallelize dh_auto_test.
    The test suite produces artifacts used at later stages which are not
    properly declared as `make` targets, causing random test failures.
  * d/control: depend on dh-sequence-python3.
  * d/lintian-overrides: fix file extension override.

 -- Andreas Tille <tille@debian.org>  Sun, 19 Oct 2025 17:02:22 +0200

=== debian/control ===
Source: metabat
Standards-Version: 4.7.2
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders:
 Andreas Tille <tille@debian.org>,
Section: science
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-python3,
 cmake,
 libboost-graph-dev,
 libboost-system-dev,
 libboost-filesystem-dev,
 libboost-serialization-dev,
 libboost-program-options-dev,
 libboost-iostreams-dev,
 zlib1g-dev,
 libhts-dev,
 pkgconf,
 python3,
Vcs-Browser: https://salsa.debian.org/med-team/metabat
Vcs-Git: https://salsa.debian.org/med-team/metabat.git
Homepage: https://bitbucket.org/berkeleylab/metabat/wiki/Home
Rules-Requires-Root: no

Package: metabat
Architecture: any-amd64 any-i386 x32
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 ${python3:Depends},
 python3,
Description: robust statistical framework for reconstructing genomes from metagenomic data
 MetaBAT integrates empirical probabilistic distances of genome abundance
 and tetranucleotide frequency for accurate metagenome binning. MetaBAT
 outperforms alternative methods in accuracy and computational efficiency
 on both synthetic and real metagenome datasets. It automatically forms
 hundreds of high quality genome bins on a very large assembly consisting
 millions of contigs in a matter of hours on a single node.

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1
export LC_ALL=C.UTF-8

include /usr/share/dpkg/default.mk

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DMETABAT_USE_SYSTEM_ZLIB=1 -DMETABAT_USE_SYSTEM_HTSLIB=1 -DCMAKE_POLICY_VERSION_MINIMUM=3.5

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	cp -a test/contigs_depth.txt obj-$(DEB_BUILD_GNU_TYPE)
	dh_auto_test --no-parallel
endif

override_dh_install:
	dh_install
	for perlscript in `grep -l '#!/usr/bin/env \+perl' debian/*/usr/bin/*` ; do \
	    sed -i '1s+#!/usr/bin/env perl+#!/usr/bin/perl+' $${perlscript} ; \
	done

override_dh_installman:
	dh_installman --language=C

=== debian/watch ===
Version: 5

Source: https://bitbucket.org/berkeleylab/metabat
Matching-Pattern: refs/tags/v(\d[.\d]+)
Git-Mode: full
Mode: git
